function doubleArray(m,n,k)
    local array, x, y = {}
    for x = 0, m
		do array[x] = {}
        for y = 0, n do
            array[x][y] = k or 0
        end
    end
    return array
end

function hitsound3(sound,x,y,r) -- thanks to JetFighter::(CS2D ELIB)
    for key, value in ipairs(player(0, "tableliving")) do
		local dx, dy = player(value, "x") - x, player(value, "y") - y
		local distance = math.sqrt(dx * dx + dy * dy)
		if distance < r then
			parse("sv_sound2 "..value.." \""..sound.."\"")
		end
	end
end


friendlybreak=true
chaintime=3
chainhealth={}
chainequiped = {}
cuff = {}
chloading = {}
chained = {}
chainedimg = {}
chrect = {}
dropimg = doubleArray(500,500)



addhook("join","_join")
function _join(id)
chloading[id] = 0
chained[id]=0
chainequiped[id]=1
chainhealth[id]=0
end




function ptoplayerdistance(id1,x,y)
	x1 = player(id1,"x")
	y1 = player(id1,"y")
	x2 = x
	y2 = y
	ank = math.abs(x2-x1)
	ggk = math.abs(y2-y1)
	hyp = ank^2 + ggk^2
	dis = math.sqrt(hyp)
	return dis
end

function unchain(pl)
if chainedimg[pl] then
freeimage(chainedimg[pl])
end
chainedimg[pl]=nil
chained[pl]=0
chainhealth[pl]=0
end

function msging(id,p)
	id=tonumber(id)
	p=tonumber(p)
	chainedimg[p]=image("gfx/sos.png",1,1,200+p)
	msg(""..player(p,"name").." has been chained by "..player(id,"name").."")
	freeimage(chloading[id])
	freeimage(chrect[id])
	freeimage(cuff[id])
	chainequiped[id] = 2
	chainhealth[p]=100
	parse("equip "..p.." 78")
	parse("setweapon "..p.." 78")
	chloading[id]=0
	parse("speedmod "..p.." 0")
	if cuff[pl] then
		freeimage(cuff[p])
		cuff[pl]=nil
	end
end

addhook("select","_select")
function _select(id,t)
	if chained[id]>0 then
		parse("setweapon "..id.." 78")
	end
	if t==74 and chainequiped[id]==1 then
		cuff[id]=image("gfx/handcuff.png",1,0,200+id)
		elseif t~=74 and chainequiped[id]==1 and cuff[id] then
		freeimage(cuff[id])
		cuff[id]=nil
	end
end

addhook("collect","_collect")
function _collect(id,iii,wpn)
	if chained[id]>0 then
	return 1
	end
	if wpn==74 then
		local x = math.floor(player(id,"x")/32)
		local y = math.floor(player(id,"y")/32)
		freeimage(dropimg[x][y])
	end
end

addhook("drop","_drop")
function _drop(id,ass,wpn,ai,a,m,x,y)
if wpn==74 and chainequiped[id]==1 then
if cuff[id] then
freeimage(cuff[id])
end
cuff[id]=nil
dropimg[x][y]=image("gfx/handcuff.png",math.floor(x*32),math.floor(y*32),0)
end
end

addhook("hit","_hit")
function _hit(p,id,ty,dmg,dm,ra,obj)
if ty<230 then
	if chained[id]>0 then
	return 1
	end
	if chainequiped[id]==1 and ty==74 and chloading[id]==0  then
						timer(chaintime*1000,"parse","lua msging("..id..","..p..")")
						chrect[id] = image("gfx/rec.png", 0,1,200+p)
						chloading[id] = image("gfx/[].png", 0,1,200+p)
						tween_scale(chloading[id],chaintime*1000,20,1)
						hitsound3("cuff_sn.ogg",player(id, "x"),player(id, "y"),100)
						imagecolor(chloading[id],255,255,0)
						imagealpha(chloading[id],1.2)
						chained[p]=id
						parse("speedmod "..p.." -100")
						return 1
	end
		if ty==50 or ty==69 or ty==74 or ty==78 or ty==85 then
			if chained[p]>0 and chained[p]~=id then
				if chainhealth[p]>0 then
					local dmg = math.random(1,30)
					chainhealth[p]=chainhealth[p]-dmg
					msg2(id,"-"..dmg.."")
					else
					unchain(p)
					msg(""..player(p,"name").." has been unchained by "..player(id,"name").."")
				end
					return 1
			end
			if chained[p]==id then
				if chainequiped[id]==2 and ty==74  then
					msg(""..player(p,"name").." has been unchained by "..player(id,"name").."")
					unchain(p)
					chainequiped[id]=1 parse("setweapon "..id.." 50") parse("setweapon "..id.." 74")
				elseif chainequiped[id]==2 and ty~=74 then
						if chainhealth[p]>0 then
							local dmg=math.random(1,30)
							chainhealth[p]=chainhealth[p]-dmg
							msg2(id,"-"..dmg.."")
						else
							unchain(p)
							msg(""..player(p,"name").." has been unchained by "..player(id,"name").."")
						end
				return 1
				end
			end
		end
	
end
end

addhook("move","moving")
function moving(id)
		if chloading[id]~=0 then
						for _,p in pairs(player(0,"tableliving")) do
							if chained[p]==id then
								chained[p]=0
								parse("speedmod "..p.." 0")
								freetimer("parse","lua msging("..id..","..p..")")
								imagealpha(chloading[id],0)
								imagealpha(chrect[id],0)
								freeimage(chloading[id])
								freeimage(chrect[id])
								chloading[id]=0
							end
						end
		end
end

addhook("die","_die")
function _die(id)
chainequiped[id]=1
		if chloading[id]~=0 then
			for _,p in pairs(player(0,"tableliving")) do
				if chained[p]==id then
					chained[p]=0
					parse("speedmod "..p.." 0")
					freetimer("parse","lua msging("..id..","..p..")")
					imagealpha(chloading[id],0)
					imagealpha(chrect[id],0)
					freeimage(chloading[id])
					freeimage(chrect[id])
					chloading[id]=0
				end
			end
		end
		unchain(id)
end

addhook("attack","_attack")
function _attack(id)
	if friendlybreak==true then
		local ty=player(id,"weapon")
	    if ty==50 or ty==69 or ty==74 or ty==78 or ty==85 then
			for _,p in pairs(player(0,"tableliving")) do
				if chained[p]>0 and player(id,"team")==player(p,"team") then
					local x = player(id,"x") local y = player(id,"y")
					if ptoplayerdistance(p,x,y)<=20 then
						if id~=p then
							if chainhealth[p]>0 then
								local dmg=math.random(1,30)
								chainhealth[p]=chainhealth[p]-dmg
								msg2(id,"-"..dmg.."")
								else
								unchain(p)
								msg(""..player(p,"name").." has been unchained by "..player(id,"name").."")
							end
						end	
                    end
				end
			end
		end
	end
end
